## netplan.io 0.106.1

=== Makefile ===
NETPLAN_SOVER=0.0

BUILDFLAGS = \
	-g \
	-fPIC \
	-std=c99 \
	-D_GNU_SOURCE \
	-DSBINDIR=\"$(SBINDIR)\" \
	-I${CURDIR}/include \
	-Wall \
	-Werror \
	$(NULL)

TESTFLAGS =	\
	-g \
	-O0 \
	-DFIXTURESDIR=\"$(shell pwd)/tests/ctests/fixtures\" \
	-Isrc \
	--coverage \
	-lcmocka \
	$(NULL)

SRCS = \
	src/abi_compat.c \
	src/error.c \
	src/names.c \
	src/netplan.c \
	src/networkd.c \
	src/nm.c \
	src/openvswitch.c \
	src/parse.c \
	src/parse-nm.c \
	src/sriov.c \
	src/types.c \
	src/util.c \
	src/validation.c \
	$(NULL)

TESTS = \
	tests/ctests/test_netplan_error \
	tests/ctests/test_netplan_misc \
	tests/ctests/test_netplan_parser \
	tests/ctests/test_netplan_state \
	$(NULL)

SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
SYSTEMD_UNIT_DIR=$(shell pkg-config --variable=systemdsystemunitdir systemd)
BASH_COMPLETIONS_DIR=$(shell pkg-config --variable=completionsdir bash-completion || echo "/etc/bash_completion.d")

GCOV ?= gcov
ROOTPREFIX ?=
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/lib
ROOTLIBEXECDIR ?= $(ROOTPREFIX)/lib
LIBEXECDIR ?= $(PREFIX)/lib
SBINDIR ?= $(PREFIX)/sbin
DATADIR ?= $(PREFIX)/share
DOCDIR ?= $(DATADIR)/doc
MANDIR ?= $(DATADIR)/man
INCLUDEDIR ?= $(PREFIX)/include

PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/cli/*.py) $(wildcard tests/netplan_dbus/*.py) $(wildcard tests/integration/*.py) $(wildcard tests/parser/*.py)

# Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
PYFLAKES3 ?= $(shell command -v pyflakes-3 || command -v pyflakes3 || echo true)
PYCODESTYLE3 ?= $(shell command -v pycodestyle-3 || command -v pycodestyle || command -v pep8 || echo true)
PYTEST3 ?= $(shell command -v pytest-3 || command -v pytest3 || echo true)
PYCOVERAGE ?= $(shell command -v python3-coverage || echo true)

default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8 doc/netplan-dbus.8 doc/netplan-get.8 doc/netplan-set.8

%.o: src/%.c src/_features.h
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -c $^ `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`

libnetplan.so.$(NETPLAN_SOVER): $(SRCS) abicompat.lds
	$(CC) -shared -Wl,-soname,libnetplan.so.$(NETPLAN_SOVER) $(BUILDFLAGS) $(CFLAGS) -fvisibility=hidden $(LDFLAGS) -o $@ $(SRCS) -T abicompat.lds `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
	ln -snf libnetplan.so.$(NETPLAN_SOVER) libnetplan.so

generate: libnetplan.so.$(NETPLAN_SOVER) generate.o
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$^) -L. -lnetplan `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`

netplan-dbus: libnetplan.so.$(NETPLAN_SOVER) dbus.o
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$(patsubst %.h,,$^)) -L. -lnetplan `pkg-config --cflags --libs libsystemd glib-2.0 gio-2.0 yaml-0.1 uuid`

src/_features.h: src/[^_]*.[hc]
	printf "#include <stddef.h>\nstatic const char *feature_flags[] __attribute__((__unused__)) = {\n" > $@
	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "\""$$2"\"," }' $^ >> $@
	echo "NULL, };" >> $@

netplan/_features.py: src/[^_]*.[hc]
	echo "# Generated file" > $@
	echo "NETPLAN_FEATURE_FLAGS = [" >> $@
	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "    \""$$2"\"," }' $^ >> $@
	echo "]" >> $@

$(TESTS): %: %.c
	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $< `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid` $(TESTFLAGS)
	./$@

clean:
	rm -f netplan/_features.py src/_features.h src/_features.h.gch
	rm -f generate doc/*.html doc/*.[1-9]
	rm -f *.o *.so*
	rm -f netplan-dbus dbus/*.service
	rm -f *.gcda *.gcno generate.info
	rm -f tests/ctests/*.gcda tests/ctests/*.gcno
	rm -rf test-coverage .coverage
	rm -f .coverage.* coverage.xml
	find . | grep -E "(__pycache__|\.pyc)" | xargs rm -rf
	rm -f $(TESTS)

check: default linting $(TESTS)
	PYTHONPATH=. LD_LIBRARY_PATH=. tests/cli_legacy.py
	PYTHONPATH=. LD_LIBRARY_PATH=. $(PYCOVERAGE) run -a -m pytest -s -v --cov-append
	tests/validate_docs.sh

linting:
	$(PYFLAKES3) $(PYCODE)
	$(PYCODESTYLE3) --max-line-length=130 $(PYCODE)

coverage: | pre-coverage c-coverage python-coverage-combine python-coverage

pre-coverage:
	rm -f .coverage
	$(MAKE) CFLAGS="-g -O0 --coverage" clean check
	mkdir -p test-coverage/C test-coverage/python

check-coverage: coverage
	@if grep headerCovTableEntryHi test-coverage/C/index.html | grep -qv '100.*%'; then \
	    echo "FAIL: Test coverage not 100%!" >&2; exit 1; \
	fi
	python3-coverage report --omit=/usr* --show-missing --fail-under=100

c-coverage:
	lcov --directory . --capture --gcov-tool=$(GCOV) -o generate.info
	lcov --remove generate.info "/usr*" -o generate.info
	genhtml -o test-coverage/C/ -t "generate test coverage" generate.info

python-coverage-combine:
	python3-coverage combine -a

python-coverage:
	python3-coverage html -d test-coverage/python --omit=/usr* || true
	python3-coverage xml --omit=/usr* || true

install: default
	mkdir -p $(DESTDIR)/$(SBINDIR) $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR) $(DESTDIR)/$(LIBDIR)
	mkdir -p $(DESTDIR)/$(MANDIR)/man5 $(DESTDIR)/$(MANDIR)/man8
	mkdir -p $(DESTDIR)/$(DOCDIR)/netplan/examples
	mkdir -p $(DESTDIR)/$(DATADIR)/netplan/netplan
	mkdir -p $(DESTDIR)/$(INCLUDEDIR)/netplan
	install -m 755 generate $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
	find netplan/ -name '*.py' -exec install -Dm 644 "{}" "$(DESTDIR)/$(DATADIR)/netplan/{}" \;
	install -m 755 src/netplan.script $(DESTDIR)/$(DATADIR)/netplan/
	ln -srf $(DESTDIR)/$(DATADIR)/netplan/netplan.script $(DESTDIR)/$(SBINDIR)/netplan
	ln -srf $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
	# lib
	install -m 644 *.so.* $(DESTDIR)/$(LIBDIR)/
	ln -snf libnetplan.so.$(NETPLAN_SOVER) $(DESTDIR)/$(LIBDIR)/libnetplan.so
	# headers, dev data
	install -m 644 include/*.h $(DESTDIR)/$(INCLUDEDIR)/netplan/
	# TODO: install pkg-config once available
	# docs, data
	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
	install -m 644 examples/*.yaml $(DESTDIR)/$(DOCDIR)/netplan/examples/
	install -m 644 doc/*.5 $(DESTDIR)/$(MANDIR)/man5/
	install -m 644 doc/*.8 $(DESTDIR)/$(MANDIR)/man8/
	install -T -D -m 644 netplan.completions $(DESTDIR)/$(BASH_COMPLETIONS_DIR)/netplan
	# dbus
	mkdir -p $(DESTDIR)/$(DATADIR)/dbus-1/system.d $(DESTDIR)/$(DATADIR)/dbus-1/system-services
	install -m 755 netplan-dbus $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
	install -m 644 dbus/io.netplan.Netplan.conf $(DESTDIR)/$(DATADIR)/dbus-1/system.d/
	install -m 644 dbus/io.netplan.Netplan.service $(DESTDIR)/$(DATADIR)/dbus-1/system-services/

%.service: %.service.in
	sed -e "s#@ROOTLIBEXECDIR@#$(ROOTLIBEXECDIR)#" $< > $@


%.html: %.md
	pandoc -s --metadata title="Netplan reference" --toc -o $@ $<

doc/netplan.5: doc/manpage-header.md doc/structure-id.md doc/netplan-yaml.md doc/manpage-footer.md
	pandoc -s -o $@ --from=markdown-smart $^

%.8: %.md
	pandoc -s -o $@ --shift-heading-level-by=-1 --from=markdown-smart $^

.PHONY: clean

=== doc/requirements.txt ===
sphinx
furo
sphinx-design
sphinxcontrib-spelling
sphinx-autobuild
pyenchant
myst-parser
sphinx-copybutton

=== debian/changelog ===
netplan.io (0.106.1-7ubuntu0.22.04.4) jammy-security; urgency=medium

  * SECURITY REGRESSION: failure on systems without dbus
    - debian/netplan.io.postinst: Don't call the generator if no networkd
      configuration file exists. (LP: #2071333) 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Fri, 28 Jun 2024 22:42:13 +0530

netplan.io (0.106.1-7ubuntu0.22.04.3) jammy-security; urgency=medium

  * SECURITY UPDATE: weak permissions on secret files, command injection
    - d/p/lp2065738/0028-libnetplan-use-more-restrictive-file-permissions.patch:
      Use more restrictive file permissions to prevent unprivileged users to
      read sensitive data from back end files (LP: #2065738, #1987842)
    - CVE-2022-4968
    - d/p/lp2066258/0029-libnetplan-escape-control-characters.patch:
      Escape control characters in the parser and double quotes in backend
      files
    - d/p/lp2066258/0030-backends-escape-file-paths.patch:
      Escape special characters in file paths
    - d/p/lp2066258/0031-backends-escape-semicolons-in-service-units.patch:
      Escape isolated semicolons in systemd service units (LP: #2066258)
  * debian/netplan.io.postinst: Add a postinst maintainer script to call the
    generator. It's needed so the file permissions fixes will be applied
    automatically, thanks to danilogondolfo 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Mon, 24 Jun 2024 23:20:42 +0530

netplan.io (0.106.1-7ubuntu0.22.04.2) jammy; urgency=medium

  * Drop d/p/sru-compat/0024-Avoid-unnecessary-export-of-API.patch.
    Also, update the .symbols file, according to SRU review.

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 04 Sep 2023 11:17:14 +0200

netplan.io (0.106.1-7ubuntu0.22.04.1) jammy; urgency=medium

  * Backport netplan.io 0.106.1-7 to 22.04 (LP: #2025519)
    - New 'netplan status' CLI (!290)
    - API: implement APIs from the new specification (!298)
    - Check and fix non-inclusive laguange (!303)
    - Documentation improvements (using Diátaxis & RTD)
    - Match by PermanentMACAddress (!278)
    - Netplan api iterator (!306)
    - API: update netplan_delete_connection() (!322)
    - NM 1.40 compat & file permission fixes (!300), LP: 1862600, LP: 1997348
    - Migrate from (deprecated) nose to pytest (!302)
    - parse: Add the filepath to OVS ports netdefs (!295)
    - Check if the interface name is too long (!313), LP: 1988749
    - doc/examples: remove unnecessary route for IPv6 on-link gateways (!312)
    - Memory leak CI action (!321)
    - tests:base:ethernets: Improve stability of autopkgtests (!223)
    - Add all the commands to the bash completion file (LP: 1749869)
    - parse-nm: fix eap_method handling (LP: 2016625)
    - ovs: don't allow peers with the same name
    - parse: validate NM backend settings usage
    - nm: check the passthrough config format
    - wireguard: plug a memory leak
    - validate: drop the YAML node parameter
    - parse: don't point to the wrong node on validation
    - parse: set the backend on nm-devices to NM by default
    - parse: plug a memory leak
    - nm: return if write_routes() fails
    - libnetplan: don't try to read from a NULL file
    - networkd: plug a memory leak
    - vrfs: skip policies parsing if list is NULL (LP: 2016427)
    - parse: use "--" with systemd-escape
    - netplan: adjust the maximum buffer size to 1MB
    - cli:status: improve networkctl parameter passing
    - cli:test: use 'text' alias instead of 'universal_newlines'
    - cli:apply: use shutil.rmtree instead of 'rm -rf'
    - Use controlled execution environment, to avoid failure if PATH is unset
      (LP: 1959570)
    - meson: fix installation of legacy /lib/netplan/generate symlink
    - dbus: Use the error set by _copy_yaml_state()
    - dbus: Build the copy path correctly (LP: 1997467)
    - parse:ovs: Ignore deprecated OpenFlow1.6 protocol (LP: 1963735)
    - parser: Don't duplicate OVS configuration (LP: 2007682)
    - parser: Don't add DNS entries duplicates (LP: 2007682)
    - parser: handle duplicated routing rules (LP: 2007682)
    - netplan: cli: fix typo from 'unkown' to 'unknown'
    - meson: cli:utils: drop legacy generator path, use libexec instead
    - meson: use meson_make_symlink.sh helper instead of install_symlink()
    - ATTN: parser: validate lacp-rate properly (LP: 1745648)
    - parser: demote the new lacp-rate check to warning
    - Don't drop files with just global values on 'set' (LP: 2027584)
      d/p/0020-netplan.c-Don-t-drop-files-with-just-global-values-o.patch
    - Add parser support for WPA3 Personal (LP: 2023238)
    - d/patches/lp2016473: Keyfile parsing for all tunnel types, LP: 2016473
    - d/p/lp2021884: WireGuard: auto append prefix to allowed IPs, LP: 2021884
    - d/p/lp1997467: Improve DEP-3 headers
    - Fix some memory leaks (!297)
    - parser: plug a memory leak (!309)
    - src:parse: plug memory leaks in nullable handling (!319)
    - Fix 'netplan ip leases' crash (!301), LP: 1996941
    - tests: mock calls to systemctl (!314)
    - ctests: fix an integer conversion issue (!315)
    - docs: small fix on netplan-set doc (!316)
    - parser: return the correct error on failure (!308), LP: 2000324
    - apply: Fix crash when OVS is stopped (!307),LP: 1995598
    - networkd: make sure VXLAN is in the right section (!310), LP: 2000713
    - cli:set: update only specific origin-hint if given (!299), LP: 1997467
    - vxlan: convert some settings to tristate (!311), LP: 2000712
    - parser: check for route duplicates (!320), LP: 2003061
    [CI]
    - CI: make use of the canonical/setup-lxd action
    - Add new spread based snapd integration test
    - Add some integration tests for DBus
    - CI: update canonical/setup-lxd to v0.1.1
    - Makefile: fully cleanup coverage data
    - spread.yaml: restore /etc/netplan for each test
    - tests: Don't use duplicated DNS entries (LP: 2007682)
    - rpm: Refresh packaging for 0.106 and sync from Fedora


=== debian/control ===
Source: netplan.io
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Netplan Maintainers <team+netplan@tracker.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>,
 Lukas Märdian <slyon@debian.org>,
Section: net
Priority: optional
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 bash-completion,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3,
 python3-coverage <!nocheck>,
 python3-dbus <!nocheck>,
 python3-pytest <!nocheck>,
 python3-pytest-cov <!nocheck>,
 python3-yaml <!nocheck>,
 python3-netifaces <!nocheck>,
 libcmocka-dev,
 libsystemd-dev,
 systemd,
 dbus-x11 <!nocheck>,
 pyflakes3 <!nocheck>,
 pycodestyle <!nocheck> | pep8 <!nocheck>,
 pandoc,
 openvswitch-switch <!nocheck>,
 meson,
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
Vcs-Browser: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
Homepage: https://netplan.io/

Package: netplan.io
Architecture: linux-any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 iproute2,
 libnetplan0 (= ${binary:Version}),
 python3,
 python3-dbus,
 python3-yaml,
 python3-netifaces,
 systemd (>= 248~),
Suggests:
 network-manager | wpasupplicant,
 openvswitch-switch,
 python3-rich,
 iw,
Conflicts: netplan
Breaks: nplan (<< 0.34~)
Replaces: nplan (<< 0.34~)
Provides: nplan
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

Package: libnetplan0
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: YAML network configuration abstraction runtime library
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.
 .
 This package contains the necessary runtime library files.

Package: libnetplan-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
 libnetplan0 (= ${binary:Version}),
Description: Development files for netplan's libnetplan runtime library
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.
 .
 This package contains development files for developers wanting to use
 libnetplan in their applications.

=== debian/tests/control ===
Test-Command: systemctl is-active openvswitch-switch.service && ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=ovs || exit 77
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  openvswitch-switch,
Restrictions: allow-stderr, needs-root, isolation-container, skip-not-installable, skippable
Features: test-name=ovs

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=ethernets
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  ethtool,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=ethernets

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=bridges
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=bridges

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=bonds
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=bonds

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=routing
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=routing

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=vlans
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=vlans

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=wifi
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  iw,
Restrictions: allow-stderr, needs-root, isolation-container, flaky
Features: test-name=wifi

Test-Command: ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=tunnels
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,

## netplan.io 0.107

=== debian/changelog ===
netplan.io (0.107-5ubuntu0.4) mantic-security; urgency=medium

  * SECURITY REGRESSION: failure on systems without dbus
    - debian/netplan-generator.postinst: Don't call the generator if no
      networkd configuration file exists. (LP: #2071333) 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Fri, 28 Jun 2024 22:17:07 +0530

netplan.io (0.107-5ubuntu0.3) mantic-security; urgency=medium

  * SECURITY UPDATE: weak permissions on secret files, command injection
    - d/p/lp2065738/0012-libnetplan-use-more-restrictive-file-permissions.patch:
      Use more restrictive file permissions to prevent unprivileged users to
      read sensitive data from back end files (LP: #2065738, #1987842)
    - CVE-2022-4968
    - d/p/lp2065738/0013-cli-generate-call-daemon-reload-after-generate.patch:
      Call systemd daemon-reload as part of the netplan generate cli command
    - d/p/lp2066258/0014-libnetplan-escape-control-characters.patch:
      Escape control characters in the parser and double quotes in backend
      files.
    - d/p/lp2066258/0015-backends-escape-file-paths.patch:
      Escape special characters in file paths.
    - d/p/lp2066258/0016-backends-escape-semicolons-in-service-units.patch:
      Escape isolated semicolons in systemd service units. (LP: #2066258)
  * debian/netplan-generator.postinst: Add a postinst maintainer script to call
    the generator. It's needed so the file permissions fixes will be applied
    automatically, thanks to danilogondolfo 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Mon, 24 Jun 2024 23:58:40 +0530

netplan.io (0.107-5ubuntu0.2) mantic; urgency=medium

  * lp1809994/0010-parse-improve-the-parsing-of-access-points-LP-180999.patch:
    Improve access-points parsing. Properly handle access-points if a second
    pass if required in the parser and not report them as duplicates
    (LP: #1809994).
  * lp1809994/0011-wifi-replace-the-previously-defined-AP-with-the-new-.patch:
    Overwrite the access-point object if another access-point with the same
    name is found instead of ignoring the new one. This behavior is closer
    to the merging process Netplan does.

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Wed, 15 Nov 2023 10:58:49 +0000

netplan.io (0.107-5ubuntu0.1) mantic; urgency=medium

  * d/p/lp2039821/0008-wireguard-ignore-empty-endpoints.patch (LP: #2039821)
    Network Manager GUIs might emit a Wireguard endpoint as an empty string
    when it's omitted. Netplan is rejecting the generated YAML. With this
    patch Netplan will just ignore empty endpoints.
  * d/p/lp2039825/0009-auth-add-support-for-LEAP-and-EAP-PWD.patch
    Netplan's keyfile parser will generate incorrect configuration when
    unsupported EAP method are used. It ends up generating invalid Network
    Manager configuration. This patch implements support for LEAP and PWD
    methods. (LP: #2039825)

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Thu, 19 Oct 2023 15:14:56 +0100

netplan.io (0.107-5) unstable; urgency=medium

  * d/p/lp2034595: Fix NetworkManager loopback interaction (LP: #2034595)

 -- Lukas Märdian <slyon@debian.org>  Thu, 14 Sep 2023 17:08:13 +0530

netplan.io (0.107-4) unstable; urgency=medium

  * Fix placeholder NetDefs in libnetplan iterator (LP: #2034024)
    d/p/0003-util-don-t-return-a-placeholder-netdef-in-the-iterat.patch
  * Relax tunnel.local validation (LP: #2034067)
    debian/patches/lp2034067/*
  * debian/patches: Update DEP-3 headers

 -- Lukas Märdian <slyon@debian.org>  Tue, 05 Sep 2023 09:37:26 +0200

netplan.io (0.107-3) unstable; urgency=medium

  * Split python3-netplan bindings into a separate package

 -- Lukas Märdian <slyon@ubuntu.com>  Sat, 26 Aug 2023 13:16:27 +0200

netplan.io (0.107-2) unstable; urgency=medium

  * d/control: Add runtime dependency on python3-cffi-backend (LP: #2031962)
  * d/t/control: Enable dummy & veth integration tests
  * Fix NetworkManager 1.44 VRF compatibility (LP: #2031421, Closes: #1049432)
    d/p/0001-parse-allow-COMMON_LINK_HANDLERS-for-VRFs-LP-2031421.patch
  * d/rules: Fix dh_clean to cleanup after tests (Closes: #1046524)
  * Fix OVS tests by avoiding NetworkManager taking control
    d/p/0002-test-ovs-Avoid-NetworkManager-taking-contol-breaking.patch
  * d/t/control: Don't hide real OVS test failures as skippable

 -- Lukas Märdian <slyon@debian.org>  Mon, 21 Aug 2023 17:25:33 +0200

netplan.io (0.107-1) unstable; urgency=medium

  * New upstream release: 0.107
    - Support for "dummy" (`dummy-devices`) interfaces (LP: #1774203) (!361)
    - Support for "veth" (`virtual-ethernets`) interfaces (!368)
    - Add Python bindings for libnetplan (!385)
    - netplan: Handle command exceptions (!334)
    - WPA3 (personal) support (LP: #2023238) (!369)
    - Add all the commands to the bash completion file (LP: #1749869) (!326)
    - New submodule for state manipulation (!379)
    - commands/status: show routes from all routing tables (!390)
    - cli:status: Make rich pretty printing optional (!388)
    - libnetplan: expose dhcp4 and dhcp6 properties (!394)
    - Expose macaddress and DNS configuration from the netdef (!395)
    - libnetplan: expose the routes list in the netdef (!397)
    - NetworkManager: Wireguard private key flag support (!371)
    - Add a netplan_parser_load_keyfile() Python binding (!351)
    - keyfile parser: add support for all tunnel types (LP: #2016473) (!360)
    - parse-nm:wg: add support for reading the listen-port property (!372)
    - parse-nm: add support for VRF devices (!398)
    - Vlan keyfile parser support (!370)
    - Netplan docs rework (!333 & !337)
    - docs: Add a short netplan-everywhere howto (!325)
    - doc: make us of sphinx copybutton plugin (!354)
    - doc: Add Ubuntu Code of Conduct 2.0 (!355)
    - doc: Explanation about 00-network-manager-all.yaml (!378)
    Bug fixes:
    - Fix FTBFS on Fedora and refresh RPM packaging (!323)
    - parser: validate lacp-rate properly (LP: #1745648) (!324)


=== debian/control ===
--- 
+++ 
@@ -16,13 +16,16 @@
  libglib2.0-dev,
  uuid-dev,
  python3,
+ python3-cffi,
  python3-coverage <!nocheck>,
  python3-dbus <!nocheck>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <!nocheck>,
+ python3-rich <!nocheck>,
  python3-yaml <!nocheck>,
  python3-netifaces <!nocheck>,
  libcmocka-dev,
+ libpython3-dev,
  libsystemd-dev,
  systemd,
  dbus-x11 <!nocheck>,
@@ -31,8 +34,8 @@
  pandoc,
  openvswitch-switch <!nocheck>,
  meson,
-Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
-Vcs-Browser: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
+Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
+Vcs-Browser: https://salsa.debian.org/debian/netplan.io
 Homepage: https://netplan.io/
 
 Package: netplan.io
@@ -43,20 +46,14 @@
  ${misc:Depends},
  iproute2,
  libnetplan0 (= ${binary:Version}),
+ netplan-generator,
  python3,
  python3-dbus,
+ python3-netplan,
+ python3-rich,
  python3-yaml,
  python3-netifaces,
  systemd (>= 248~),
-Suggests:
- network-manager | wpasupplicant,
- openvswitch-switch,
- python3-rich,
- iw,
-Conflicts: netplan
-Breaks: nplan (<< 0.34~)
-Replaces: nplan (<< 0.34~)
-Provides: nplan
 Description: YAML network configuration abstraction for various backends
  netplan reads YAML network configuration files which are written
  by administrators, installers, cloud image instantiations, or other OS
@@ -65,6 +62,55 @@
  networking daemon.
  .
  Currently supported backends are networkd and NetworkManager.
+
+Package: netplan-generator
+Architecture: linux-any
+Multi-Arch: foreign
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ libnetplan0 (= ${binary:Version}),
+ systemd (>= 248~),
+Suggests:
+ network-manager | wpasupplicant,
+ openvswitch-switch,
+ iw,
+Breaks: netplan.io (<< 0.106.1-8~),
+Replaces: netplan.io (<< 0.106.1-8~),
+Description: YAML network configuration abstraction systemd-generator
+ netplan reads YAML network configuration files which are written
+ by administrators, installers, cloud image instantiations, or other OS
+ deployments. During early boot it then generates backend specific
+ configuration files in /run to hand off control of devices to a particular
+ networking daemon.
+ .
+ Currently supported backends are networkd and NetworkManager.
+ .
+ This package provides a systemd-generator to configure networking daemons
+ at boot time.
+
+Package: python3-netplan
+Section: python
+Architecture: linux-any
+Multi-Arch: foreign
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ libnetplan0 (= ${binary:Version}),
+ python3,
+ python3-cffi-backend,
+Breaks: netplan.io (<< 0.107-3~)
+Replaces: netplan.io (<< 0.107-3~)
+Description: YAML network configuration abstraction Python bindings
+ netplan reads YAML network configuration files which are written
+ by administrators, installers, cloud image instantiations, or other OS
+ deployments. During early boot it then generates backend specific
+ configuration files in /run to hand off control of devices to a particular
+ networking daemon.
+ .
+ Currently supported backends are networkd and NetworkManager.
+ .
+ This package provides a CFFI based Python bindings to libnetplan.
 
 Package: libnetplan0
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson

override_dh_auto_clean:
	dh_auto_clean
	make clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dpython.purelibdir=/usr/lib/python3/dist-packages \
		-Dpython.platlibdir=/usr/lib/python3/dist-packages

execute_after_dh_auto_install:
	# Drop __pycache__
	rm -rf debian/tmp/usr/lib/python3/dist-packages/netplan/__pycache__/
	# Drop legacy symlink
	rm debian/tmp/lib/netplan/generate
	# Fix non-usrmerged paths & drop legacy symlink
	# rm -rf debian/tmp/lib
	# mkdir -p debian/tmp/usr/lib/systemd/system-generators
	# ln -s /usr/libexec/netplan/generate debian/tmp/usr/lib/systemd/system-generators/netplan

## netplan.io 0.107.1

=== Makefile ===
.PHONY: clean default check linting pre-coverage
VER = $(shell meson introspect _build/ --projectinfo | jq -r '.version' && rm -rf _build)

DESTDIR ?= ../tmproot

default: _build
	meson compile -C _build --verbose

_build:
	meson setup _build --prefix=/usr

_build-cov:
	meson setup _build-cov --prefix=/usr -Db_coverage=true

clean:
	rm -f netplan_cli/_features.py src/_features.h src/_features.h.gch
	rm -f generate doc/*.html doc/*.[1-9]
	rm -f *.o *.so*
	rm -f netplan-dbus dbus/*.service
	rm -f *.gcda *.gcno generate.info
	rm -f tests/ctests/*.gcda tests/ctests/*.gcno
	rm -rf test-coverage .coverage
	rm -f .coverage.* coverage.xml
	find . | grep -E "(__pycache__|\.pyc)" | xargs rm -rf
	rm -rf build
	rm -rf _build
	rm -rf _build-cov
	rm -rf _leakcheckbuild
	rm -rf tmproot
	rm -f python-cffi/netplan/_netplan_cffi.*

dist: clean _build
	tar --exclude="_build" --exclude=".git" --exclude="debian" --exclude=".vscode" -cvJf ../netplan-$(VER).tar.xz .
	ln -sf netplan-$(VER).tar.xz ../netplan.io_$(VER).orig.tar.xz  # Debian .orig symlink

check: default
	meson test -C _build --verbose

linting: _build
	meson test -C _build --verbose linting
	meson test -C _build --verbose codestyle

pre-coverage: _build-cov
	meson compile -C _build-cov --verbose

check-coverage: pre-coverage
	meson test -C _build-cov --verbose

install: default
	meson install -C _build --destdir $(DESTDIR)

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
# This is for development purposes only, e.g. to run a local Sphinx
# development environment.  Usage:
#
# Setup: Run `make install` from doc/ to setup a Python virtual env
# Devel: Run `make run` from doc/ to get a live preview of your changes
# Test:  Run `make spelling` from doc/ to validate your spelling
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

VENV = env/bin/activate
PORT = 8090

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

install:
	@echo "... setting up virtualenv"
	python3 -m venv env
	. $(VENV); pip install --upgrade -r requirements.txt
	@echo "\n" \
	  "--------------------------------------------------------------- \n" \
      "* watch, build and serve the documentation: make run \n" \
	  "* check spelling: make spelling \n" \
	  "\n" \
      "enchant must be installed in order for pyenchant (and therefore \n" \
	  "spelling checks) to work. \n" \
	  "--------------------------------------------------------------- \n"

clean:
	-rm -rf _build/*

run:
	. $(VENV); sphinx-autobuild $(ALLSPHINXOPTS) --ignore ".git/*" --ignore "*.scss" . -b dirhtml -a _build/html --host 0.0.0.0 --port $(PORT)

test:
	. $(VENV); $(SPHINXBUILD) -b html . _build/html

html:
	. $(VENV); $(SPHINXBUILD) -b dirhtml . _build/html

spelling:
	. $(VENV); $(SPHINXBUILD) -b spelling $(ALLSPHINXOPTS) . _build/spelling
	@echo
	@echo "Check finished. Wrong words can be found in " \
		"_build/spelling/output.txt."

quickstart:
	. $(VENV); sphinx-quickstart

.PHONY: help install clean run Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== doc/requirements.txt ===
--- 
+++ 
@@ -6,3 +6,4 @@
 pyenchant
 myst-parser
 sphinx-copybutton
+breathe

=== debian/changelog ===
netplan.io (0.107.1-3ubuntu0.22.04.2) jammy; urgency=medium

  * debian/patches/lp1988018: VF-LAG activation
    Fixes the order in which SR-IOV configuration is performed and
    cooperates with VF-LAG activation (LP: #1988018).
  * debian/patches/lp2020409:
    Enables setting the embedded-switch mode without having to define
    virtual functions (LP: #2020409).
  * debian/libnetplan0.symbols: New symbol _netplan_netdef_get_bond_mode.

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Mon, 07 Oct 2024 10:57:38 +0100

netplan.io (0.107.1-3ubuntu0.22.04.1) jammy; urgency=medium

  * Backport netplan.io 0.107.1-3 to 22.04 (LP: #2058031):
    - Support for "dummy" (`dummy-devices`) interfaces (LP: 1774203) (!361)
    - Support for "veth" (`virtual-ethernets`) interfaces (!368)
    - Add Python bindings for libnetplan (!385)
    - netplan: Handle command exceptions (!334)
    - WPA3 (personal) support (LP: 2023238) (!369)
    - Add all the commands to the bash completion file (LP: 1749869) (!326)
    - New submodule for state manipulation (!379)
    - commands/status: show routes from all routing tables (!390)
    - cli:status: Make rich pretty printing optional (!388)
    - libnetplan: expose dhcp4 and dhcp6 properties (!394)
    - Expose macaddress and DNS configuration from the netdef (!395)
    - libnetplan: expose the routes list in the netdef (!397)
    - NetworkManager: Wireguard private key flag support (!371)
    - Add a netplan_parser_load_keyfile() Python binding (!351)
    - keyfile parser: add support for all tunnel types (LP: 2016473) (!360)
    - parse-nm:wg: add support for reading the listen-port property (!372)
    - parse-nm: add support for VRF devices (!398)
    - Vlan keyfile parser support (!370)
    - Netplan docs rework (!333 & !337)
    - docs: Add a short netplan-everywhere howto (!325)
    - doc: make us of sphinx copybutton plugin (!354)
    - doc: Add Ubuntu Code of Conduct 2.0 (!355)
    - doc: Explanation about 00-network-manager-all.yaml (!378)
    - wifi: add support for WPA3-Enterprise (LP: 2029876) (!402)
    - wifi: support WPA2 and WPA3 Personal simultaneously (!404)
    - added mii-monitor-interval example (!411)
    - docs: Add "Contribute Documentation" how-to
    - auth: add support for LEAP and EAP-PWD (!415)
    - tests: Add autopkgtest for (LP: 1959570) (!419)
    - wifi: make it possible to have a psk and an eap password simultaneously
      (!416)
    - doc: Set-up some basic Doxygen project (!423)
    - doc: Make Sphinx to handle autodoxygen project, using breathe (!423)
    - doc: create libnetplan apidoc structure (!423)
    - inc: Start documenting public API (!423)
    - doc: Update 'Netplan everywhere' for 23.10 (!418)
    SECURITY UPDATE: weak permissions on secret files, command injection
    - d/p/lp2065738/0014-libnetplan-use-more-restrictive-file-permissions.patch:
      Use more restrictive file permissions to prevent unprivileged users to
      read sensitive data from back end files (LP: 2065738, 1987842)
    - CVE-2022-4968
    - d/p/lp2066258/0015-libnetplan-escape-control-characters.patch:
      Escape control characters in the parser and double quotes in backend
      files.
    - d/p/lp2066258/0016-backends-escape-file-paths.patch:
      Escape special characters in file paths.
    - d/p/lp2066258/0017-backends-escape-semicolons-in-service-units.patch:
      Escape isolated semicolons in systemd service units. (LP: 2066258)
    - debian/netplan-generator.postinst: Add a postinst maintainer script to
      call the generator. It's needed so the file permissions fixes will be
      applied automatically.
    Bug fixes:
    - Fix FTBFS on Fedora and refresh RPM packaging (!323)
    - parser: validate lacp-rate properly (LP: 1745648) (!324)
    - use meson-make-symlink.sh helper instead of install_symlink() (!327)
    - netplan: cli: fix typo from 'unkown' to 'unknown' (!328)
    - Handle duplication during parser second pass (LP: 2007682) (!329)
    - parse:ovs: Ignore deprecated OpenFlow1.6 protocol (LP: 1963735) (!332)
    - dbus: Build the copy path correctly (!331)
    - tests: add new spread based snapd integration test (!330)
    - Use controlled execution environment, to avoid failure if PATH is unset
      (LP: 1959570) (!336)
    - Some refactoring (!338)
    - netplan: adjust the maximum buffer size to 1MB (!340)
    - parse: use "--" with systemd-escape (!347)
    - docs: fix bridge parameters types and add examples (!346)
    - vrfs: skip policies parsing if list is NULL (LP: 2016427) (!341)
    - networkd: plug a memory leak (!344)
    - libnetplan: don't try to read from a NULL file (!342)
    - nm: return if write_routes() fails (!345)
    - parse: plug a memory leak (!348)
    - parse: set the backend on nm-devices to NM (!349)
    - parse: don't point to the wrong node on validation (!343)
    - rtd: set the OS and Python versions explicitly (!357)
    - Fix 8021x eap method parsing (LP: 2016625) (!358)
    - CI: update canonical/setup-lxd to v0.1.1 (!359)
    - CI: fix dch after adding the new 0.106.1 tag (!364)
    - Provide frequency to wpa_supplicant in adhoc mode (LP: 2020754) (!363)
    - Improve the coverage of the memory leak tests (!365)
    - Fix keyfile parsing of wireguard config (!366)
    - routes: fix metric rendering (LP: 2023681) (!367)
    - CI: add DebCI integration test (!362)
    - CI: initial NetworkManager autopkgtests (!374)
    - parse-nm: handle cloned-mac-address special cases (LP: 2026230) (!376)
    - Improve autopkgtest stability with systemd 253 & iproute 6.4 (!377)
    - Fixes for minor issues (!380)
    - tests:integration: Adopt for systemd v254 (Closes: #1041310) (!381)
    - parse: Downgrade NM passthrough warning to debug (!384)
    - Don't drop files with just global values (LP: 2027584) (!382)
    - Fixing Coverity issues (!383)
    - CLI: Refactoring to avoid namespace clash with public bindings (!387)


=== debian/control ===
--- 
+++ 
@@ -21,7 +21,6 @@
  python3-dbus <!nocheck>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <!nocheck>,
- python3-rich <!nocheck>,
  python3-yaml <!nocheck>,
  python3-netifaces <!nocheck>,
  libcmocka-dev,
@@ -34,8 +33,8 @@
  pandoc,
  openvswitch-switch <!nocheck>,
  meson,
-Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
-Vcs-Browser: https://salsa.debian.org/debian/netplan.io
+Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
+Vcs-Browser: https://git.launchpad.net/~ubuntu-core-dev/netplan/+git/ubuntu
 Homepage: https://netplan.io/
 
 Package: netplan.io
@@ -50,10 +49,14 @@
  python3,
  python3-dbus,
  python3-netplan,
- python3-rich,
  python3-yaml,
  python3-netifaces,
  systemd (>= 248~),
+Suggests: python3-rich
+Conflicts: netplan
+Breaks: nplan (<< 0.34~)
+Replaces: nplan (<< 0.34~)
+Provides: nplan
 Description: YAML network configuration abstraction for various backends
  netplan reads YAML network configuration files which are written
  by administrators, installers, cloud image instantiations, or other OS

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson

override_dh_auto_clean:
	dh_auto_clean
	make clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dpython.purelibdir=/usr/lib/python3/dist-packages \
		-Dpython.platlibdir=/usr/lib/python3/dist-packages

execute_after_dh_auto_install:
	# Drop __pycache__
	rm -rf debian/tmp/usr/lib/python3/dist-packages/netplan/__pycache__/

=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,4 @@
-Test-Command: systemctl is-active openvswitch-switch.service && ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=ovs || exit 77
+Test-Command: (systemctl is-active openvswitch-switch.service || exit 77) && ./debian/tests/prep-testbed.sh && python3 tests/integration/run.py --test=ovs
 Tests-Directory: tests/integration
 Depends: @,
   systemd-resolved | systemd (<< 251.3-2~),
@@ -104,4 +104,3 @@
 Depends: @,
   systemd-resolved | systemd (<< 251.3-2~),
   network-manager,
-  hostapd,
